/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const a=require("vue"),p=require("@progress/kendo-vue-animation"),t=require("@progress/kendo-vue-common"),r=require("../common/utils.js"),m=require("../common/constants.js"),P=require("../package-metadata.js"),$=a.defineComponent({name:"KendoProgressBar",props:{animation:{type:[Boolean,Object],default:!1},disabled:{type:Boolean,default:!1},reverse:{type:Boolean,default:!1},label:String,labelRender:[String,Object,Function],labelVisible:{type:Boolean,default:!0},labelPlacement:{type:String,default:void 0,validator:function(e){return["start","center","end"].includes(e)}},dir:{type:String,default:void 0},max:{type:Number,default:100},min:{type:Number,default:0},value:{type:Number,default:0},orientation:{type:String,default:"horizontal",validator:function(e){return["horizontal","vertical"].includes(e)}},tabIndex:Number,emptyStyle:Object,emptyClassName:String,progressStyle:Object,progressClassName:String,ariaLabel:String},created(){t.validatePackage(P.packageMetadata),this.currentDir=this.$props.dir},mounted(){this._progressStatus=t.getRef(this,"progressStatus"),this._progressStatusWrap=t.getRef(this,"progressStatusWrap"),this.currentDir=this.$props.dir!==void 0?this.$props.dir:t.isRtl(this.$el)?"rtl":"ltr",this.animationFrame=p.animate({duration:this.animationDuration,onStart:this.handleStart,onUpdate:this.handleUpdate,onEnd:this.handleEnd})},unmounted(){p.cancelAnimation(this.animationFrame)},data(){return{currentDir:void 0}},watch:{value:function(e,s){this.prevValue=s,this.animationFrame=p.animate({duration:this.animationDuration,onStart:this.handleStart,onUpdate:this.handleUpdate,onEnd:this.handleEnd})}},computed:{wrapperClass(){const{disabled:e,reverse:s,orientation:n,value:o}=this.$props,i=n==="vertical";return{"k-progressbar":!0,"k-progressbar-horizontal":!i,"k-progressbar-vertical":i,"k-progressbar-reverse":s,"k-progressbar-indeterminate":o===null,"k-disabled":e}},isVertical(){return this.orientation==="vertical"},animationDuration(){const{animation:e}=this.$props;return typeof e!="boolean"&&e!==void 0?e.duration:e?m.DEFAULT_ANIMATION_DURATION:m.NO_ANIMATION}},render(){const{disabled:e,labelVisible:s,labelPlacement:n,max:o,min:i,tabIndex:d,emptyStyle:b,emptyClassName:u,progressStyle:f,progressClassName:c}=this.$props,l=this.$props.value||0,S=this.$props.value===null,v=r.truncateNumber(l),y={value:l},N=this.$props.labelRender?t.templateRendering.call(this,this.$props.labelRender,t.getListeners.call(this)):void 0,k=a.h("span",{class:"k-progress-status"},v),V=t.getTemplate.call(this,{h:a.h,template:N,defaultRendering:k,additionalProps:y}),h=s?this.$props.label?a.createVNode("span",{class:"k-progress-status"},[this.$props.label]):V:void 0,g=t.classNames("k-progress-status-wrap",{"k-progress-start":n==="start","k-progress-center":n==="center","k-progress-end":n==="end"||n===void 0});return a.createVNode("div",{class:this.wrapperClass,dir:this.currentDir,tabindex:t.getTabIndex(d,e),role:"progressbar","aria-valuemin":i,"aria-valuemax":o,"aria-valuenow":S?void 0:l,"aria-disabled":e,"aria-label":this.$props.ariaLabel},[a.createVNode("span",{class:g+(u?" "+u:""),style:b},[h]),a.createVNode("div",{class:"k-progressbar-value k-selected",style:f,ref:t.setRef(this,"progressStatus")},[a.createVNode("span",{class:g+(c?" "+c:""),ref:t.setRef(this,"progressStatusWrap")},[h])])])},methods:{focus(){this.$el&&this.$el.focus()},progressStatusElement(){return this._progressStatus},progressStatusWrapElement(){return this._progressStatusWrap},handleStart(){const e=r.calculatePercentage(this.min,this.max,this.prevValue);r.updateProgress(this._progressStatus,this._progressStatusWrap,e,this.isVertical)},handleUpdate(e){const s=r.calculatePercentage(this.min,this.max,this.prevValue+(this.value-this.prevValue)*e);r.updateProgress(this._progressStatus,this._progressStatusWrap,s,this.isVertical)},handleEnd(){const e=r.calculatePercentage(this.min,this.max,this.value);r.updateProgress(this._progressStatus,this._progressStatusWrap,e,this.isVertical)}}});exports.ProgressBar=$;
